// =================================================================
// Database.h
// =================================================================
// Harold Kasperink / John Dekker 
// Dr. Dobb's Journal 1997
// =================================================================
#ifndef _DATABASE_H_
#define _DATABASE_H_

#include "dbarray.h"
#include "oracle.h"

////////////////////////////////////////////////////////////////////
// CDbCommit
////////////////////////////////////////////////////////////////////
class CDbCommit : public CDbCommand
{
private:
	boolean	m_bUnlock;

public:
	CDbCommit(CDbase &dbase, boolean bUnlock = TRUE);
	virtual ~CDbCommit();
	
	virtual void	Do(); 

private:
	virtual long	Execute();
};

////////////////////////////////////////////////////////////////////
// CDbRollback
////////////////////////////////////////////////////////////////////
class CDbRollback : public CDbCommand
{
private:
	boolean	m_bUnlock;

public:
	CDbRollback(CDbase &dbase, boolean bUnlock = TRUE);
	virtual ~CDbRollback();
	
	virtual void	Do(); 

private:
	virtual long	Execute();
};

////////////////////////////////////////////////////////////////////
// CDbConnect
////////////////////////////////////////////////////////////////////
class CDbConnect : public CDbCommand
{
private:
	char*	m_pszConnect;
	
public:
	CDbConnect(CDbase &dbase,char* pszConnect);
	virtual ~CDbConnect();
	
	virtual void	Do(); 

private:
	virtual long	Execute();
};

////////////////////////////////////////////////////////////////////
// CDbDisConnect
////////////////////////////////////////////////////////////////////
class CDbDisConnect : public CDbCommand
{
private:
	boolean	m_bUnlock;

public:
	CDbDisConnect(CDbase &dbase);
	virtual ~CDbDisConnect();
	
	virtual void	Do(); 

private:
	virtual long	Execute();
};

////////////////////////////////////////////////////////////////////
// CDbFindPerson
////////////////////////////////////////////////////////////////////
class CDbFindPerson : public CDbCommand
{
private:
	boolean	m_bUnlock;
	char	*m_pszFirstName;
	char	*m_pszLastName;

public:
	CDbFindPerson(char *pszFirstName, char *pszLastName);
	virtual ~CDbFindPerson();
	
	virtual void	Do(); 

private:
	virtual long	Execute();
};

#endif
